#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

void traitementVador();
void traitementLuke();
int jedi (int vador);
int sith (int luke);

void traitementVador(){
	printf("Dark\n");
}


void traitementLuke(){
	printf("Force\n");
}

void traitementInit(){}


int jedi (int vador){
	
	if(signal(SIGUSR1, traitementLuke) == SIG_ERR){
		perror("erreur de signal");
		return 1;
	}
	printf("Luke ready\n");
	pause();
	usleep(rand()%5000);
	printf("Luke tries to kill Vador\n");
	kill(vador, SIGKILL);
	printf("Luke wins\n");

	return EXIT_SUCCESS ;

}

int sith (int luke){

	if(signal(SIGUSR1, traitementVador) == SIG_ERR){
		perror("erreur de signal");		
		return 1;
	}
	printf("Vador ready\n");
	pause();
	usleep(rand()%5000);
	printf("Vador tries to kill Luke\n");
	kill(luke, SIGKILL);
	printf("Vador wins\n");

	return EXIT_SUCCESS;

}








int main(int argc,char* argv[]){

	int status, luke;
	int vador_pid;
	int vador =fork();
	
	srand(time(NULL));
	
	
	switch(vador){
		case -1 :
			perror("erreur de fork");
			return 1;
			break;
		case  0 : 
			vador_pid=getpid();
			luke = fork();
			switch(luke){
				case -1 : 
					perror("erreur de fork");
					return 1;
					break;
				case 0 : 
					jedi(vador_pid);
					break;
				default : 
					sith(luke);
			}
			break;
		default:
			usleep(1000000);
			if(signal(SIGUSR1, traitementInit )== SIG_ERR ){
				perror("Mauvais signal");
			}
			printf("BATTLE\n");
			kill(0, SIGUSR1);				
			
			do{
				waitpid(0, &status, WUNTRACED | WCONTINUED);
			}while( !WIFEXITED(status) && !WIFSIGNALED(status)); 
	}
	return EXIT_SUCCESS;
}





