#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>


void traitantPong(){
	printf("Pong\n");
}

void traitantPing(){
	printf("Ping\n");
}

void traitantGame(){}

int main(int argc,char* argv[]){
	int ping=fork();
	int pong;
	int playerPlaying=0;
	switch(ping){
		case -1 :
			perror("erreur de fork");
			return 1;
			break;
		case  0 : 
			pong = fork();
			switch(pong){
				case -1 :
					perror("erreur de fork");
					return 1;
					break;
				case  0 :
					while (1){
						if(signal(SIGUSR2, traitantPong)== SIG_ERR ){
							perror("Mauvais signal");
						}
						if(signal(SIGUSR1, traitantEmpty)== SIG_ERR ){
							perror("Mauvais signal");
						}
						pause();
					}
					break;
				default:
					while(1){					
						if(signal(SIGUSR1, traitantPing)== SIG_ERR ){
							perror("Mauvais signal");
						}
						if(signal(SIGUSR2, traitantEmpty)== SIG_ERR ){
							perror("Mauvais signal");
						}
						pause();
					}
			}			
			break;
		default:
			while (1){
				if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				if(signal(SIGUSR1, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				if(signal(SIGUSR2, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				alarm(2);
				pause();
				if (playerPlaying == 0){
					playerPlaying=1;
					kill(0, SIGUSR1);
				}
				else{
					playerPlaying=0;
					kill(0,SIGUSR2);
				}
			}
	}
	return EXIT_SUCCESS;
}
